DebuffWindow = class( Turbine.UI.Control )

function DebuffWindow:Constructor(  )
    Turbine.UI.Control.Constructor( self )

    --self.curable_per_row = math.floor((_G.settings["width"]/2)/_G.settings["curable_size"])
    --self.debuffs_per_row = math.floor((_G.settings["width"])/_G.settings["debuff_size"])
    self.curable_per_row = math.floor(_G.settings["width"]/_G.settings["curable_size"])

    self:SetSize(_G.settings["width"], WINDOW_HEIGHT/2)
    self:SetMouseVisible(false)
    
    -- self.debuffs = Turbine.UI.ListBox()
    -- self.debuffs:SetParent(self)
    -- self.debuffs:SetSize(_G.settings["width"], WINDOW_HEIGHT/2)
    -- self.debuffs:SetOrientation(Turbine.UI.Orientation.Horizontal)
    -- self.debuffs:SetFlippedLayout(true)
    -- self.debuffs:SetMaxColumns(self.debuffs_per_row )
    -- self.debuffs:SetMouseVisible(false)

    self.curable = Turbine.UI.ListBox()
    self.curable:SetParent(self)
    self.curable:SetSize(_G.settings["width"], WINDOW_HEIGHT/2)
    self.curable:SetOrientation(Turbine.UI.Orientation.Horizontal)
    self.curable:SetReverseFill(true)
    self.curable:SetMaxColumns(self.curable_per_row )
    self.curable:SetMouseVisible(false)

end

function DebuffWindow:AddEffect(effect)

    --if effect:IsCurable() then
        self.curable:AddItem(EffectIcon(effect, _G.settings["curable_size"], _G.settings["curable_font"]))
    --    self:CalcNewDebuffColumnCount()
        self:SortCurable()
    -- else
    --     self.debuffs:AddItem(EffectIcon(effect, _G.settings["debuff_size"], _G.settings["debuff_font"]))
    --     self:SortDebuffs()
    -- end

end

-- function DebuffWindow:CalcNewDebuffColumnCount()
--     self.debuffs:SetMaxColumns(math.floor((_G.settings["width"]-(math.min(self.curable:GetItemCount(),self.curable_per_row)*_G.settings["curable_size"]))/_G.settings["debuff_size"]))
-- end

function DebuffWindow:RemoveEffect(effect)

    --if effect:IsCurable() then
        for i=1, self.curable:GetItemCount(), 1 do
            if self.curable:GetItem(i).effect == effect then
                self.curable:GetItem(i):Close()
                self.curable:RemoveItem(self.curable:GetItem(i))
      --          self:CalcNewDebuffColumnCount()
                break
            end
        end
    -- else
    --     for i=1, self.debuffs:GetItemCount(), 1 do
    --         if self.debuffs:GetItem(i).effect == effect then
    --             self.debuffs:GetItem(i):Close()
    --             self.debuffs:RemoveItem(self.debuffs:GetItem(i))
    --             break
    --         end
    --     end
    -- end

end

function DebuffWindow:ClearEffects()
    for i=1, self.curable:GetItemCount(), 1 do
        self.curable:GetItem(i):Close()
        self.curable:RemoveItem(self.debuffs:GetItem(i))
    end
    -- self:CalcNewDebuffColumnCount()

    -- for i=1, self.debuffs:GetItemCount(), 1 do
    --     self.debuffs:GetItem(i):Close()
    --     self.debuffs:RemoveItem(self.debuffs:GetItem(i))
    -- end
end

-- function DebuffWindow:SortDebuffs()
--     self.debuffs:Sort(function(elem1,elem2) if elem1.ending>elem2.ending then return true end end)
-- end

function DebuffWindow:SortCurable()
    self.curable:Sort(function(elem1,elem2) if elem1.ending>elem2.ending then return true end end)
end